-- Copyright (C) 2023:
--   Helmholtz-Zentrum Potsdam Deutsches GeoForschungsZentrum GFZ
--
-- This program is free software: you can redistribute it and/or modify it
-- under the terms of the GNU Affero General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or (at
-- your option) any later version.
--
-- This program is distributed in the hope that it will be useful, but
-- WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
-- General Public License for more details.
--
-- You should have received a copy of the GNU Affero General Public License
-- along with this program. If not, see http://www.gnu.org/licenses/.

-- Converts tile XY coordinates into pixel XY coordinates of the upper-left pixel
-- of the specified tile.
-- Adapted from https://learn.microsoft.com/en-us/bingmaps/articles/bing-maps-tile-system

CREATE OR REPLACE FUNCTION tile_xy_to_pixel_xy(
    IN tile_x INT,
    IN tile_y INT,
    OUT pixel_x INT,
    OUT pixel_y INT
)
LANGUAGE plpgsql IMMUTABLE PARALLEL SAFE
AS $$
BEGIN
    pixel_x := tile_x * 256;
    pixel_y := tile_y * 256;
END;
$$;
